package metrics

import (
	"testing"

	"xbus.io/xbus/storage"
	"xbus.io/xbus/testutils"
	"xbus.io/xbus/testutils/mocks"
	storagetest "xbus.io/xbus/testutils/storage"
)

func envelopeStorageFactory(tb testing.TB) (storage.EnvelopeStorage, func()) {
	tb.Helper()

	return NewEnvelopeStorage(
		tb.Name(), "mock", mocks.NewEnvelopeStorage(testutils.GetTestLogger(tb)),
	), func() {}
}

func TestEnvelopeStorage(t *testing.T) {
	storagetest.EnvelopeStorageTests(t, envelopeStorageFactory, storagetest.EnvelopeStorageTestsOptions{
		SupportUnordered:     true,
		SupportParallelStore: true,
	})
}
