package utils

import "fmt"

// ByteCountBinaryInt64 returns a human readable byte size of a int64
func ByteCountBinaryInt64(b int64) string {
	abs := b
	if b < 0 {
		abs = -b
	}
	s := ByteCountBinaryUInt64(uint64(abs))
	if b < 0 {
		s = "-" + s
	}
	return s
}

// ByteCountBinaryUInt64 returns a human readable byte size of a uint64
func ByteCountBinaryUInt64(b uint64) string {
	const unit = 1024
	if b < unit {
		return fmt.Sprintf("%d B", b)
	}
	div, exp := int64(unit), 0
	for n := b / unit; n >= unit; n /= unit {
		div *= unit
		exp++
	}
	return fmt.Sprintf("%.1f %ciB", float64(b)/float64(div), "KMGTPE"[exp])
}
